package nl.amis.hrm;

import java.util.Iterator;

import java.util.List;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import oracle.adf.view.rich.component.rich.data.RichTable;

import oracle.adf.view.rich.render.ClientEvent;

import oracle.jbo.Key;
import oracle.jbo.domain.Number;

public class HrmManagerBean {

    private boolean shouldCreateEmployee = false;
    private boolean shouldSelectEmployee = false;
    private oracle.jbo.domain.Number selectEmpno;
    private RichTable empTable;

    public HrmManagerBean() {
    }

    public String createEmployee() {
        shouldCreateEmployee = true;
        return "create";
    }

    public String editEmployee() {
        shouldSelectEmployee = true;
        return "edit";
    }

    public void setShouldCreateEmployee(boolean shouldCreateEmployee) {
        this.shouldCreateEmployee = shouldCreateEmployee;
    }

    public boolean isShouldCreateEmployee() {
        return shouldCreateEmployee;
    }

    public void setShouldSelectEmployee(boolean shouldSelectEmployee) {
        this.shouldSelectEmployee = shouldSelectEmployee;
    }

    public boolean isShouldSelectEmployee() {
        return shouldSelectEmployee;
    }

    public void setSelectEmpno(Number selectEmpno) {
        this.selectEmpno = selectEmpno;
    }

    public Number getSelectEmpno() {
        return selectEmpno;
    }

    public void setEmpTable(RichTable empTable) {
        this.empTable = empTable;
    }

    public RichTable getEmpTable() {
        return empTable;
    }

    public void goEditCurrentRow(ClientEvent clientEvent) {
        // Add event code here...
        Iterator keys = getEmpTable().getSelectedRowKeys().iterator();
        while (keys.hasNext()) {
            Key key = (Key)((List)keys.next()).get(0);
            this.selectEmpno = (Number)key.getKeyValues()[0];
        }
        
        FacesContext ctx = FacesContext.getCurrentInstance();
        UIViewRoot newPage =
            ctx.getApplication().getViewHandler().createView(ctx,
                                                             "/EmployeeEditPage.jspx");
        ctx.setViewRoot(newPage);
        ctx.renderResponse();
        // instruct the BindingContainer for the EmployeeEdit page to setCurrentRowWithKey
        this.setShouldSelectEmployee(true);
    }
}
